/**
 * Prefill texts.
 */
var prefill = [
	'',
	'Ik heb je gebeld omdat je interesse hebt getoond in de MedApp apotheek. Ik probeer het later nog eens. Je kunt ons tijdens kantooruren bellen op 040-3046533 of mailen naar apotheek@medapp.nl',
	'Ik ga je straks bellen omdat je interesse hebt getoond in de MedApp apotheek. Ik gebruik dit nummer. Hopelijk tot straks.'
];

/**
 * Get the mobile number and fill the form.
 * 
 * @param Object data
 *   Entity data.
 * @return void
 */
function fillForm(data)
{
	$('#entity').val(data.Entity);
	$('#entityid').val(data.EntityId);
	ZOHO.CRM.API.getRecord({Entity:data.Entity,RecordID:data.EntityId})
	.then(function(record) {
		var mobile = record.data[0].Mobile;
		$('#number').val('+' + mobile.substr(2));
		$('#message').val(prefill[1]);
		$('#charcount').html($('#message').val().length);
	});
}

/**
 * Initialize the widget. Called once.
 * 
 * This function implements the PageLoad event handler,
 * initialized the widget and
 * registers the button click event handler. 
 * 
 * @returns void
 */
function initializeWidget()
{
	/*
	 * Subscribe to the EmbeddedApp onPageLoad event before initializing the widget 
	 */
	ZOHO.embeddedApp.on("PageLoad",function(data)
	{
		//ZOHO.CRM.UI.Resize({height:"120"});
		
	 	// Verify if EntityInformation is passed.
		if(data && data.Entity)
		{
			// Fill the form.
			fillForm(data);
		}

	});
	
	/*
	 * initialize the widget.
	 */
	ZOHO.embeddedApp.init();
	
}

// Event handlers.
$(document).ready(function(){
	
	// Select template message.
	$(document).on('change', '#prefill', function(){
		var index = $(this).val();
		if ( index > 0 ) {
			$('#message').val(prefill[$(this).val()]);
		}
	});
	
	// Edit message.
	$(document).on('keyup', '#message', function(){
		var len = $('#message').val().length;
		$('#charcount').html(len);
		if ( len <= 140 ) {
			$('#charcount').removeClass('toolong');
		}
		else {
			$('#charcount').addClass('toolong');			
		}
	});
	
	// Send SMS button.
	$(document).on('click', '#submit', function(){
		$.ajax({
			url: 'https://rest.messagebird.com/messages',
			type: 'post',
			headers: {
				Authorization: 'AccessKey 4sX8ve9Ry64Ykka32xyGWPCFU',
				Accept: 'application/json'
			},
			crossDomain: true,
			data: {
				recipients: $('#number').val(),
				originator: 'MedApp',
				body: $('#message').val()
			},
			success: function() {
				$('#result').html('<span style="color:green;">Succesvol verstuurd</span>');
				setTimeout(function(){
					ZOHO.CRM.UI.Popup.close().then(function(){});
				},1000);
				// Add SMS call.
				var Entity = $('#entity').val();
				var recordData = {
					'$se_module': $('#entity').val(),
					'What_Id': $('#entityid').val(),
					'Subject': 'Pre-intake SMS',
					'Description': $('#message').val(),
					'Call_Type': 'Outbound',
					'Call_Duration': '00:01',
					'Call_Result': 'SMS gestuurd',
					'Call_Purpose': 'SMS'
				};
				ZOHO.CRM.API.insertRecord({Entity:"Calls",APIData:recordData,Trigger:["workflow"]});
			},
			error: function(jqXHR, textStatus, errorThrown) {
				$('#result').html('<span style="color:red;">Versturen mislukt</span>');
			}
		});
	});
	
});
